Index: /SMC/trunk/SMC/docs/userdocs.rst
===================================================================
--- /SMC/trunk/SMC/docs/userdocs.rst	(revision 3444)
+++ /SMC/trunk/SMC/docs/userdocs.rst	(revision 3445)
@@ -15,9 +15,11 @@
 and elements or data categories as leaf nodes, parent-child relationship being defined by the inclusion (``componentA -includes-> componentB``) or referencing (``elementA -refersTo-> datcat1``).The reuse of components in multiple profiles and especially also the referencing of the same data categories in multiple CMD elements leads to a blending of the individual profile trees into a graph (acyclic directed, but not necessarily connected).
 
-SMC Browser visualizes this graph structure in an interactive fashion.
-
-It is implemented on top of wonderful js-library d3_, more technical documentation follows soon.
+SMC Browser visualizes this graph structure in an interactive fashion. You can have a look at the `examples`_ for inspiration.
+
+It is implemented on top of wonderful js-library d3_, the code checked in `clarin-svn`_ (and needs refactoring). More technical documentation follows soon.
 
 .. _d3: https://github.com/mbostock/d3
+.. _clarin-svn: https://svn.clarin.eu/SMC/trunk/SMC
+.. _examples: examples.html
 
 
@@ -33,4 +35,13 @@
 The same goes for elements in reused components. In most cases it is indicated in the label, if the number reflect distinct items, or all (expanded) occurrences.
 
+(Some of the) numbers in the statistics lead to a list of corresponding terms. 
+E.g. in the summary for a profile, clicking on the components-number lists all the components of given profile alphabetically.
+Currently there are such lists for:
+
+  * ``profile -> components`` 
+  * ``profile -> elements``
+  * ``profile -> data categories``
+  * ``data category -> profiles``
+
 .. _Component Registry: http://catalog.clarin.eu/ds/ComponentRegistry/#
 .. _ISOcat: http://www.isocat.org
@@ -106,4 +117,12 @@
   clicking on an item in the detail pane unselects it
 
+select in statistics 
+	as mentioned in `Data`_ (some) numbers in the statistics reveal a list of corresponding terms.
+	Clicking on these terms in the statistics page leads to the browser, with given term as selected node (and default settings)
+	
+select in statistics in the detail pane
+  the numbers from statistics page are shown also in the detail pane for selected nodes.
+  Here, clicking on a term from these lists adds it to the graph, as a selected node.
+  
 mouseover 
   on mouse over a node, all connected nodes to given node (and connecting links) within the visible sub-graph are highlighted 
@@ -112,5 +131,5 @@
 drag a node
   click and hold on a node, one can move the node around, however usually the layout is stronger 
-  and puts the node back to its original position
+  and puts the node back to its original position. Not so with the freeze-layout, that freezes all the nodes and lets you move them around freely
 
 Options
@@ -131,4 +150,9 @@
 	the higher the charge, the more the nodes tend to drift apart
 	
+friction
+  factor for "cooling down" the layout, lower numbers (50-70) stabilize the graph more quickly, 
+  but it may be too early, with higher numbers (95-100) the layout has more time/freedom to arrange,
+  but may get jittery
+  
 node-size
   N = all nodes have given diameter N;
@@ -146,6 +170,6 @@
   
 layout
-  There are a few layouting algorithms provided, 
-  for different data displayed other algorithm may be more appropriate:
+  There are a few layouting algorithms provided. They are all not optimal in any way, but most of the time, they deliver quite good results.
+  For different data displayed other algorithm may be more appropriate:
   
   force
@@ -155,5 +179,6 @@
     top-down layout respect the direction of the edges, children are always below the parents
   horizontal-tree
-    left-right layout respect the direction of the edges, children are always right to the parents
+    left-right layout respect the direction of the edges, children are always right to the parents 
+    (at least they should be, currently, in certain configurations, the layout does not get the orientation for some links right)
   weak-tree
     a layout that "tends" towards left to right arrangement, but not strictly so (experimental)	  	   
@@ -192,11 +217,4 @@
 .. _server-side processing: http://d3export.cancan.cshl.edu/
   
-  
-Examples
-========
-
-`DCMI terms`_
-
-.. _DCMI terms: ?link-distance=24&charge=107&layout=force&selected=clarin_eucr1p_1288172614023,clarin_eucr1p_1288172614026&
  
 Issues
@@ -220,4 +238,5 @@
 * Add information from **RelationRegistry** (relations between DatCats)
 * Blend in instance data from **MDRepository** (allow search on MDRepository)
+* graph operations (intersect, difference of subrgraphs)
 
 Smaller enhancements of the user interface:
@@ -229,6 +248,5 @@
 * backlinking from detail (e.g. view all the profiles a data category is used in by clicking on the number ('used in profiles')
 * store/export SVG/PDF/PNG-renderings of the graphs
-* add layout ``freeze`` static layout, were individual nodes can be moved around freely
 * add edge-weight: scale based on usage, i.e. how often appears the relation in the complete dataset
   i.e. often reused combinations of components/elements will be nearer
-	
+* allow to blend in further (private) CMD-profiles dynamically