Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index.html	(revision 3457)
@@ -93,5 +93,5 @@
 background="index_files/image552.png" style='margin:0'>
 <!--[if gte vml 1]><v:background id="_x0000_s3073" o:bwmode="white"
- fillcolor="#dbe1e5" o:targetscreensize="1680,905">
+ fillcolor="#dbe1e5" o:targetscreensize="1920,1047">
  <v:fill focus="100%" type="gradient"/>
 </v:background><![endif]-->
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/12620.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/12620.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/12620.html	(revision 3457)
@@ -62,5 +62,5 @@
 style='margin:0'>
 <!--[if gte vml 1]><v:background id="_x0000_s3073" o:bwmode="white"
- fillcolor="#e0e6e6" o:targetscreensize="1680,905">
+ fillcolor="#e0e6e6" o:targetscreensize="1920,1047">
  <v:fill color2="white [7]" focus="100%" type="gradient"/>
 </v:background><![endif]-->
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/TDGs.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/TDGs.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/TDGs.html	(revision 3457)
@@ -64,5 +64,5 @@
 <body link=blue vlink=purple bgcolor="#DAE1EB" style='margin:0'>
 
-<div style='position:absolute;width:7.-71in;height:31.-1771in'>
+<div style='position:absolute;width:7.-71in;height:31.-1750in'>
 <!--[if gte vml 1]><v:rect id="_x0000_s1516" style='position:absolute;left:234pt;
  top:231pt;width:336pt;height:336pt;z-index:70;mso-wrap-distance-left:2.88pt;
@@ -904,5 +904,5 @@
  <o:lock v:ext="edit" shapetype="t"/>
 </v:shapetype><v:shape id="_x0000_s1566" type="#_x0000_t201" style='position:absolute;
- left:175.5pt;top:175.5pt;width:525.48pt;height:2110.26pt;z-index:77;
+ left:175.5pt;top:175.5pt;width:525.48pt;height:2110.41pt;z-index:77;
  mso-wrap-distance-left:2.88pt;mso-wrap-distance-top:2.88pt;
  mso-wrap-distance-right:2.88pt;mso-wrap-distance-bottom:2.88pt' stroked="f"
@@ -922,5 +922,5 @@
 
 <table v:shapes="_x0000_s1566" cellpadding=0 cellspacing=0 width=701
- height=2814 border=0 dir=ltr style='width:525.48pt;height:2110.26pt;
+ height=2814 border=0 dir=ltr style='width:525.48pt;height:2110.41pt;
  border-collapse:collapse;position:absolute;top:175.5pt;left:175.5pt;
  z-index:77'>
@@ -1388,5 +1388,5 @@
  <tr>
   <td width=701 height=35 colspan=3 bgcolor="#E0E6E6" style='width:525.48pt;
-  height:26.0944pt;padding-left:1.5pt;padding-right:1.5pt;padding-top:1.5pt;
+  height:26.2479pt;padding-left:1.5pt;padding-right:1.5pt;padding-top:1.5pt;
   padding-bottom:1.5pt;background:#E0E6E6;border-left:solid black 6.0pt;
   border-top:solid black .25pt;border-right:solid black 2.0pt;border-bottom:
@@ -1421,5 +1421,5 @@
  </tr>
  <tr>
-  <td width=701 height=65 colspan=3 bgcolor="#E0E6E6" style='width:525.48pt;
+  <td width=701 height=66 colspan=3 bgcolor="#E0E6E6" style='width:525.48pt;
   height:49.2459pt;padding-left:1.5pt;padding-right:1.5pt;padding-top:1.5pt;
   padding-bottom:1.5pt;background:#E0E6E6;border-left:solid black 6.0pt;
@@ -1455,5 +1455,5 @@
  </tr>
  <tr>
-  <td width=701 height=254 colspan=3 bgcolor="#E0E6E6" style='width:525.48pt;
+  <td width=701 height=253 colspan=3 bgcolor="#E0E6E6" style='width:525.48pt;
   height:190.3437pt;padding-left:1.5pt;padding-right:1.5pt;padding-top:1.5pt;
   padding-bottom:1.5pt;background:#E0E6E6;border-left:solid black 6.0pt;
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/feedback.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/feedback.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/feedback.html	(revision 3457)
@@ -65,5 +65,5 @@
 style='margin:0'>
 <!--[if gte vml 1]><v:background id="_x0000_s3073" o:bwmode="white"
- fillcolor="#dbe1e5" o:targetscreensize="1680,905">
+ fillcolor="#dbe1e5" o:targetscreensize="1920,1047">
  <v:fill focus="100%" type="gradient"/>
 </v:background><![endif]-->
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/issues.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/issues.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/issues.html	(revision 3457)
@@ -65,5 +65,5 @@
 style='margin:0'>
 <!--[if gte vml 1]><v:background id="_x0000_s3073" o:bwmode="white"
- fillcolor="#dbe1e5" o:targetscreensize="1680,905">
+ fillcolor="#dbe1e5" o:targetscreensize="1920,1047">
  <v:fill focus="100%" type="gradient"/>
 </v:background><![endif]-->
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/manual.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/manual.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/manual.html	(revision 3457)
@@ -62,5 +62,5 @@
 style='margin:0'>
 <!--[if gte vml 1]><v:background id="_x0000_s3073" o:bwmode="white"
- fillcolor="#dbe1e5" o:targetscreensize="1680,905">
+ fillcolor="#dbe1e5" o:targetscreensize="1920,1047">
  <v:fill focus="100%" type="gradient"/>
 </v:background><![endif]-->
Index: /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/news.html
===================================================================
--- /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/news.html	(revision 3456)
+++ /cats/ISOcat/trunk/mod-ISOcat-site/site/index_files/news.html	(revision 3457)
@@ -844,4 +844,14 @@
   12.75pt'>&nbsp;</span><span lang=en-US style='font-family:Verdana;language:
   en-US'>updated to General Interface 3.9.2 r1111 to fix IE 10 support</span></p>
+  <p class=MsoNormal style='margin-left:54.0pt;text-indent:-18.0pt'><span
+  style='direction:ltr;unicode-bidi:embed;font-family:"Times New Roman";
+  font-size:10.0pt;language:x-none;color:black'>â</span><span style='width:
+  12.75pt'>&nbsp;</span><span lang=en-US style='font-family:Verdana;language:
+  en-US'>made the internal API more RESTful</span></p>
+  <p class=MsoNormal style='margin-left:54.0pt;text-indent:-18.0pt'><span
+  style='direction:ltr;unicode-bidi:embed;font-family:"Times New Roman";
+  font-size:10.0pt;language:x-none;color:black'>â</span><span style='width:
+  12.75pt'>&nbsp;</span><span lang=en-US style='font-family:Verdana;language:
+  en-US'>added caching to disk for DC DCIF representations</span></p>
   <p class=MsoNormal><span lang=en-US style='font-family:Verdana;font-weight:
   bold;language:en-US'>&nbsp;</span></p>